// File: StackStA10.h

#include<iostream.h>

template<class T>
class Stack {
private:
   short size;
   T  *mem;         // Anfang des zugehoerigen Speichers
   T  *top;         // aktuelles Element
public:
   Stack(short s);
   ~Stack();
   T pop();
   void push(T c);
   int empty();
   int full();

   friend ostream& operator << <>(ostream&, const class Stack<T>&);
   friend istream& operator >> <>(istream&, class Stack<T>&);
};

template<class T>
Stack<T>::Stack(short s)
{
   top = mem = new T[size = s];
}

template<class T>
Stack<T>::~Stack()
{
   delete[] mem;
}

template<class T>
void Stack<T>::push(T c)
{
   if(!full())
      *top++ = c;
}

template<class T>
T Stack<T>::pop()
{
   if(!empty())
      return *--top;
   return 0;
}

template<class T>
int Stack<T>::empty()
{
   return mem == top;
}

template<class T>
int Stack<T>::full()
{
   return mem + size == top;
}

template<class T>
ostream& operator<<(ostream& ros, const class Stack<T>& s)
{
  for(T *i = s.mem; i < s.top; i++)
    ros << *i << endl;

  return ros;
}

template<class T>
istream& operator>>(istream& ris, class Stack<T>& s)
{
  T t;

  while(ris >> t)
    s.push(t);

  return ris;
}
