// File: Streams11StA09.cc

#include <fstream.h>

class Complex
{
  double re, im;

public:
  Complex(double _re = 0, double _im = 0)
  : re(_re), im(_im){}

friend ostream& operator<<(ostream&, const Complex&);
friend istream& operator>>(istream&, Complex&);
};

ostream& operator<<(ostream& ros, const Complex& rc)
{
  if(&ros == &cout)
    return ros << '(' << rc.re << ',' << rc.im << ')';
  else
    return ros << rc.re << ' ' << rc.im;
}
istream& operator>>(istream& ris, Complex& rc)
{
  return ris >> rc.re >> rc.im;
}

int main()
{
    Complex z;

    ifstream in("complex.dat");
    if(!in)
    {
      cout << "complex.dat nicht vorhanden." << endl
           << "Neue komplexe Zahl eingeben: <Realteil><Leerz.><Imag.-Teil>"
           << endl;
      cin >> z;
      ofstream out("complex.dat");
      if(!out)
      {
        cerr << "Fehler beim Speichern!" << endl;
        return 3;
      }
      out << z;
      cout << "Zahl " << z << " in complex.dat gesichert." << endl;
    }
    else
    {
      cout << "complex.dat vorhanden. Lese Zahl ein." << endl;
      in >> z;
      cout << "gelesene Zahl: " << z << endl;
    }
}
