// File: mainExceptExA03.cc

#include <stdio.h>
#include <stdlib.h>
#include <new>
#include <typeinfo>

#include "xallocExA02.h"

const String xalloc::MakeString(const char *format, size_t size)
{
  static char str[0xff];

  sprintf(str, format, size); return str;
}

void *operator new[] (size_t size)
{
  void* p = malloc(size);

  if(!p)
    throw xalloc(size);

  return p;
}

void operator delete[] (void *p)
{
  free(p);
}

const size_t SegmentSize[2] =
{
  1024u * 1024u * 200u,
  1024u * 1024u * 10u
};

const int nSegments = 2;

int main()
{
  char *p;

  for(int i = 0; i < nSegments; i++)
  {
    try
    {
      p = new char[SegmentSize[i]];
    }
    catch(xmsg& ex)
    {
      cout << "Exception catched:\n\t" << ex.what() << endl;
      p = NULL;
    }
    printf("Allocation result for size=%u: p=%p\n", SegmentSize[i], p);
    delete[] p;
  }
}
